Attribute VB_Name = "ImageFunctions"
Option Explicit

Private Const DLL_NAME = "ImageFunctions.dll"
Public Const PI = 3.14159265358979

'Error codes
Public Const OK = 0
Public Const IMAGEFUNCTIONS_ERROR_IMAGE_DIMENSIONS = 1  'ERR_IMAGE_DIMENSIONS           1
Public Const IMAGEFUNCTIONS_ERROR_PARAMETERS = 2        'ERR_PARAMETERS                 2
Public Const IMAGEFUNCTIONS_ERROR_MISC = 3              'ERR_MISC                       3
Public Const IMAGEFUNCTIONS_ERR_TOO_MANY_RESULTS = 4    'ERR_TOO_MANY_RESULTS           4
Public Const IMAGEFUNCTIONS_ERROR_TRY_CATCH_FAIL = 99   'ERR_POINTER                    99
Public Const IMAGEFUNCTIONS_ERROR_ACTIVATION = 100      'ERR_NOT_ACTIVATED              100

'########################
'Image handling functions
'########################

Public Declare Function FS_AllocateImage Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lImageWidth As Long, ByVal lImageHeight As Long, ByVal lImageDepth As Long) As Long
'long _stdcall AllocateImage(colour_image* src, long lImageWidth, long lImageHeight, long lImageDepth)
'Allocates an image

Public Declare Function FS_CreateCopyImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long) As Long
'long _stdcall CreateCopyImage(colour_image* src, colour_image** dest);
'Creates a duplicate of an image

Public Declare Function FS_CreateEmptyImage Lib "ImageFunctions.dll" (ByRef src As Long) As Long
'long _stdcall CreateEmptyImage(colour_image** img)
'Creates and allocates an image

Public Declare Function FS_CreateImage Lib "ImageFunctions.dll" (ByRef src As Long, ByVal lImageWidth As Long, ByVal lImageHeight As Long, ByVal lImageDepth As Long) As Long
'long _stdcall CreateImage(colour_image** img, long lImageWidth, long lImageHeight, long lImageDepth)
'Creates and allocates an image

Public Declare Function FS_CreateMapImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long) As Long
'long _stdcall CreateMapImage(colour_image* src, colour_image* *destimg, long lLeft, long lTop, long lRight, long lBottom)
'Creates an image using the same memory as the source image.

Public Declare Function FS_DeAllocateImage Lib "ImageFunctions.dll" (ByVal src As Long) As Long
'long _stdcall DeAllocateImage(colour_image* src)
'Clears the memory associated with the image

Public Declare Function FS_DeleteImage Lib "ImageFunctions.dll" (ByRef src As Long) As Long
'long _stdcall DeleteImage(colour_image* src)
'Clears the memory associated with the image and its handle

Public Declare Function FS_FlipBGR Lib "ImageFunctions.dll" (ByVal src As Long) As Long
'long _stdcall FlipBGR(colour_image* src)
'Adjust the pointer and ZInc to reflect the fact that the data is flipped. Also sets a flag so that the image can be safely deleted

Public Declare Function FS_SetImageArea Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lValue As Long) As Long
'long _stdcall FS_SetImageArea (colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long lValue);
'Sets area to the appropriate pixel value. Colour pixels are in byte order RGB.

Public Declare Function FS_GetImagePixel Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lX As Long, ByVal lY As Long) As Long
'long _stdcall GetImagePixel (colour_image* src, long lX, long lY)
'Returns the appropriate pixel value. Colour pixels are in byte order RGB. Errors are represented by negative values.

Public Declare Function FS_SetImagePixel Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lX As Long, ByVal lY As Long, ByVal lValue As Long) As Long
'long _stdcall FS_SetImagePixel (colour_image* src, long lX, long lY, long lValue);
'Sets the appropriate pixel value. Colour pixels are in byte order RGB.

Public Declare Function FS_GetImageProperties Lib "ImageFunctions.dll" (ByVal src As Long, ByRef lImageData As Long, ByRef lImageSize As Long, ByRef lImageWidth As Long, ByRef lImageHeight As Long, ByRef lImageDepth As Long, ByRef lXInc As Long, ByRef lYInc As Long, ByRef lZInc As Long) As Long
'long _stdcall GetImageProperties(colour_image* src, long* lImageData, long* lSize, long* lImageWidth, long* lImageHeight, long* lImageDepth, long* lXInc, long* lYInc, long* lZInc)
'Gets all the properties of an image in one go

Public Declare Function FS_GetPlaneImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lPlane As Long) As Long
'long _stdcall GetPlaneImage(colour_image* src, colour_image* *destimg, long lPlane)
'Creates an image using the same memory as the source image.

Public Declare Function FS_ImageDepth Lib "ImageFunctions.dll" (ByVal src As Long) As Long
'long _stdcall ImageDepth(colour_image* src)
'Returns the image's depth. Errors are represented by negative values

Public Declare Function FS_ImageHeight Lib "ImageFunctions.dll" (ByVal src As Long) As Long
'long _stdcall ImageHeight(colour_image* src)
'Returns the image's height. Errors are represented by negative values

Public Declare Function FS_ImageWidth Lib "ImageFunctions.dll" (ByVal src As Long) As Long
'long _stdcall ImageWidth(colour_image* src)
'Returns the image's width. Errors are represented by negative values

Public Declare Function FS_IsAllocated Lib "ImageFunctions.dll" (ByVal src As Long) As Long
'long _stdcall IsAllocated(colour_image* src)
'Is there any memory allocated to this image. Returns 0 or 1 with no error codes.

Public Declare Function FS_IsFSImage Lib "ImageFunctions.dll" (ByVal img As Long) As Boolean
'BOOL _stdcall FS_IsFSImage(colour_image* hImage)
'Is the pointer an image

Public Declare Function FS_WrapImage Lib "ImageFunctions.dll" (ByRef src As Long, ByVal lImageData As Long, ByVal lImageSize As Long, ByVal lImageWidth As Long, ByVal lImageHeight As Long, ByVal lImageDepth As Long, ByVal lXInc As Long, ByVal lYInc As Long, ByVal lZInc As Long) As Long
'long _stdcall WrapImage(colour_image** src, long lImageData, long lSize, long lImageWidth, long lImageHeight, long lImageDepth, long lXInc, long lYInc, long lZInc)
'Create an image using supplied data and properties

'Image to/from memory functions
Public Declare Function FS_ImageSizeInMemory Lib "ImageFunctions.dll" (ByRef src As Long, ByRef lSize As Long) As Long
'long _stdcall FS_ImageSizeInMemory(colour_image* src, long* lSize);
'The amount of memory required for the image.

Public Declare Function FS_ImageToMemory Lib "ImageFunctions.dll" (ByVal src As Long, ByVal pMemory As Long) As Long
'long _stdcall FS_ImageToMemory(colour_image* src, void* pMemory);
'Copy image into a block of memory allocated elsewhere.

Public Declare Function FS_DuplicateImageFromMemory Lib "ImageFunctions.dll" (ByRef pdest As Long, ByVal pMemory As Long) As Long
'long _stdcall FS_DuplicateImageFromMemory(colour_image** pDest, void* pMemory);
'Copy image out of a block of memory into a new image - this duplicates the image in the block including its flags.

Public Declare Function FS_CopyImageFromMemory Lib "ImageFunctions.dll" (ByRef pdest As Long, ByVal pMemory As Long) As Long
'long _stdcall FS_CopyImageFromMemory(colour_image** pDest, void* pMemory);
'Copy image out of a block of memory into a new image - this creates a new image and copies the source image.

Public Declare Function FS_WrapImageFromMemory Lib "ImageFunctions.dll" (ByRef pdest As Long, ByVal pMemory As Long) As Long
'long _stdcall FS_WrapImageFromMemory(colour_image** pDest, void* pMemory);
'Create an image based on an image in a block of memory - this includes the flags.

Public Declare Sub FS_TerminateThreads Lib "ImageFunctions.dll" ()
'void _stdcall FS_TerminateThreads()

'##########################
'Image processing functions
'##########################

Public Declare Function FS_AddImage Lib "ImageFunctions.dll" (ByVal Src1 As Long, ByVal Src2 As Long, ByRef dest As Long) As Long
'long _stdcall AddImage(colour_image* src1, colour_image* src2, colour_image* dest)
'Adds two images together
'Does not wrap round so adding 254 to 9 gives 255

Public Declare Function FS_AddValue Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lValue As Long) As Long
'long _stdcall AddValue(colour_image* src, colour_image* dest, long lValue)
'Add a value to an image
'Use a negative value to subtract
'Does not wrap round so subracting 128 from 97 gives 0 and adding 254 to 9 gives 255

Public Declare Function FS_AndImage Lib "ImageFunctions.dll" (ByVal Src1 As Long, ByVal Src2 As Long, ByRef dest As Long) As Long
'long _stdcall AndImage(colour_image* src1, colour_image* src2, colour_image* dest)
'Ands two images together
'Writes to a destination image in which each pixel is the logical AND of the two equivalent source pixels

Public Declare Function FS_AnnularContrast Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lThickness As Long, ByRef lContrast As Long) As Long
'long _stdcall FS_AnnularContrast (colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long lThickness, long* lContrast)

Public Declare Function FS_BayerToColourHalf Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lOrientation As Long) As Long
'long _stdcall BayerToColourHalf (colour_image* src, colour_image** pdest, long lOrientation)

Public Declare Function FS_BayerToColourFull Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lOrientation As Long) As Long
'long _stdcall BayerToColourFull (colour_image* src, colour_image** pdest, long lOrientation)

Public Declare Function FS_BayerToMono Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lOrientation As Long) As Long
'long _stdcall BayerToMono (colour_image* src, colour_image** pdest, long lOrientation)

Public Declare Function FS_Binarise Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLowerThreshold As Long, ByVal lUpperThreshold As Long) As Long
'long _stdcall Binarise(colour_image* src, colour_image* dest, long lLowerThreshold, long lUpperThreshold)
'Binarises an image, with the values between and including the thresholds being 255 and others 0

Public Declare Function FS_ColourToMono Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long) As Long
'long _stdcall FS_ColourToMono(colour_image* src, colour_image** pdest)
'Converts a colour image to a mono one

Public Declare Function FS_CopyArea Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lTargetX As Long, ByVal lTargetY As Long) As Long
'long _stdcall CopyArea(colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long lTargetX, long lTargetY)
'Copies a rectangular area of one image to another

Public Declare Function FS_CopyColourImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal Reflect As Long, ByVal Invert As Long, ByVal Rotate As Long) As Long
'long _stdcall CopyColourImage(colour_image* src, colour_image* dest, BOOL bReflect, BOOL bInvert, BOOL bRotate)
'Copies and transforms an image

Public Declare Function FS_CopyColourImage2 Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal mirror As Long, ByVal Angle As Long) As Long
'long _stdcall FS_CopyColourImage2(colour_image* src, colour_image** pdest, bool bMirror, long lAngle)
'Copies and transforms an image - angle must be 0, 90, 180 or 270.

Public Declare Function FS_Corner Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lTileSizeX As Long, ByVal lTileSizeY As Long) As Long
'long _stdcall FS_Corner(colour_image* src, colour_image** pdest, long lTileSizeX, long lTileSizeY)
'Identify good search targets in an image

Public Declare Function FS_CylinderUnwrapV Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long) As Long
'long _stdcall FS_CylinderUnwrapV (colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom);
'Transforms an image of cylinder into an image of a flat plane

Public Declare Function FS_ShrinkImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lGranularity As Long) As Long
'long _stdcall ShrinkImage (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long lGranularity)
'Creates a reduced size image by sub-sampling. Granularity is the pixel step

Public Declare Function FS_ShrinkMax Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lGranularity As Long) As Long
'long _stdcall ShrinkMax (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long lGranularity)
'Creates a reduced size image by sub-sampling taking the maximum value of each quadlet. Granularity is the pixel step

Public Declare Function FS_ShrinkMin Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lGranularity As Long) As Long
'long _stdcall ShrinkMin (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long lGranularity)
'Creates a reduced size image by sub-sampling taking the minimum value of each quadlet. Granularity is the pixel step

Public Declare Function FS_ShrinkImageSmoothed Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lGranularity As Long) As Long
'long _stdcall ShrinkImageSmoothed (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long lGranularity)
'Creates a reduced size image by averaging taking the average value of each quadlet. Granularity is the pixel step.

Public Declare Function FS_ShrinkImageSmoothedHV Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lGranularityH As Long, ByVal lGranularityV As Long) As Long
'long _stdcall FS_ShrinkImageSmoothedHV (colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom, long lGranularityH, long lGranularityV);
'Creates a reduced size image by averaging taking the average value of each quadlet. Granularity is the pixel step.

Public Declare Function FS_DifferenceImage Lib "ImageFunctions.dll" (ByVal Src1 As Long, ByVal Src2 As Long, ByRef dest As Long) As Long
'long _stdcall DifferenceImage(colour_image* src1, colour_image* src2, colour_image* dest)
'Finds the difference image of two images

Public Declare Function FS_DrawStretchedCircle Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lValue As Long, ByVal bAdd As Boolean) As Long
'long _stdcall DrawStretchedCircle(colour_image* src, colour_image* srclong lLeft, long lTop, long lRight, long lBottom, long lValue, BOOL bAdd)
'Draws a stretched circle on an image, either writing in the value or adding it
'The circle is specified by its bounding rectangle.

Public Declare Function FS_ExpandImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lGranularity As Long) As Long
'long _stdcall ExpandImage (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long lGranularity)
'Creates an expanded image by super-sampling. Granularity is the pixel step

Public Declare Function FS_ExpandImageHV Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lGranularityX As Long, ByVal lGranularityY As Long) As Long
'long _stdcall FS_ExpandImageHV (colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom, long lGranularityX, long lGranularityY)
'Creates an expanded image by super-sampling. Granularity is the pixel step in X and Y.

'Public Declare Function FS_ExtractRange Lib "ImageFunctions.dll" (ByVal ImageSrc As Long, ByRef ImageDest As Long, ByVal lLowerThreshold As Long, ByVal lUpperThreshold As Long) As Long
''long _stdcall ExtractRange (IMG pImageIn, IMG *pImageOut, long lLowLimit, long lHighLimit)
''All pixels outside of the specified range are set to 0. The limits are included in the range
'
Public Declare Function FS_FindAngle Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef lAngle As Long, ByVal lSobelThreshold As Long, ByVal lMinAngle As Long, ByVal lMaxAngle As Long) As Long
'long _stdcall FindAngle (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long *plAngle, long lSobelThreshold, long lMinAngle, long lMaxAngle)
'Find the dominant angle in an ROI. Return an image showing the rotated projection.

Public Declare Function FS_FindAngleHough Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lFactor As Long, ByRef lAngle As Long, ByVal lSobelThreshold As Long, ByVal lMinAngle As Long, ByVal lMaxAngle As Long) As Long
'long _stdcall FS_FindAngleHough (colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom, long lFactor, long *plAngle, long lSobelThreshold, long lMinAngle, long lMaxAngle)
'Find the dominant angle in an ROI. Return an image showing the rotated projection.

Public Declare Function FS_FindThreshold Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef plThreshold As Long) As Long
'long _stdcall FS_FindThreshold (colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long *plThreshold)

Public Declare Function FS_FindBestPlane Lib "ImageFunctions.dll" (ByVal src As Long, ByRef lBestPlane As Long) As Long
'Find plane with highest contrast
'long _stdcall FS_FindBestPlane (colour_image* src, long* lBestPlane)

Public Declare Function FS_FindEdge Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lRow As Long, ByVal lStart As Long, ByVal lEnd As Long, ByVal lMinContrast As Long, ByVal lFilterWidth As Long, ByRef plResult As Long, ByRef plContrast As Long) As Long
'long _stdcall FindEdge (colour_image* src, colour_image* srclong lRow, long lStart, long lEnd, long lMinContrast, long lFilterWidth, long *plResult, long *plContrast)
'Find the first edge in a projection or image

Public Declare Function FS_GaussianFilter Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long) As Long
'long _stdcall FS_GaussianFilter (colour_image* src, colour_image** pdest)

Public Declare Function FS_HistogramAnnulus Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lThickness As Long, ByRef HGram As Long) As Long
'long _stdcall FS_HistogramAnnulus(colour_image* src, long lLeft, long lTop, long lRight, long lThickness, long lBottom, long *HGram)
'Histograms an annular area of an image.
'The call requires Dim HGram(256) as long, and HGram(0) is passed to the function

Public Declare Function FS_HistogramInfo Lib "ImageFunctions.dll" (ByRef HGram As Long, ByVal lLeftTailPercentage As Long, ByVal lRightTailPercentage As Long, ByRef lLeftTail As Long, ByRef lRightTail As Long, ByRef lMean As Long, ByRef lMedian As Long, ByRef lEnergy As Long, ByRef lPixels As Long) As Long
'DllExport long _stdcall FS_HistogramInfo(long *HGram, long lLeftTailPercentage, long lRightTailPercentage, long *lLeftTail, long *lRightTail, long *lMean, long *lMedian, long *lEnergy, long *lPixels)
'Extracts three percentiles, the mean and "energy" from a histogram
'The call requires Dim HGram(256) as long, and HGram(0) is passed to the function

Public Declare Function FS_HistogramInfoAnnulus Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lLeftTailPercentage As Long, ByVal lRightTailPercentage As Long, ByRef lLeftTail As Long, ByRef lRightTail As Long, ByRef lMean As Long, ByRef lMedian As Long, ByRef lEnergy As Long) As Long
'long _stdcall FS_HistogramInfoAnnulus(colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long lThickness, long lLeftTailPercentage, long lRightTailPercentage, long *lLeftTail, long *lRightTail, long *lMean, long *lMedian, long *lEnergy)
'Extracts three percentiles, the mean and "energy" from a histogram
'The call requires Dim HGram(256) as long, and HGram(0) is passed to the function

Public Declare Function FS_HistogramROI Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef HGram As Long) As Long
'DllExport long _stdcall FS_HistogramROI(colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long *HGram)
'Histograms an area of an image.
'The call requires Dim HGram(256) as long, and HGram(0) is passed to the function

Public Declare Function FS_HistogramEllipse Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef HGram As Long) As Integer
'DllExport long _stdcall FS_HistogramEllipse(colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long *HGram)
'Histograms an elliptical area of an image.
'The call requires Dim HGram(256) as long, and HGram(0) is passed to the function

Public Declare Function FS_HistogramInfoROI Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lLeftTailPercentage As Long, ByVal lRightTailPercentage As Long, ByRef lLeftTail As Long, ByRef lRightTail As Long, ByRef lMean As Long, ByRef lMedian As Long, ByRef lEnergy As Long) As Long
'DllExport long _stdcall FS_HistogramInfoROI(colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long lLeftTailPercentage, long lRightTailPercentage, long *lLeftTail, long *lRightTail, long *lMean, long *lMedian, long *lEnergy)
'Histograms an area of an image, and returns three percentiles, the mean and "energy".

Public Declare Function FS_HistogramInfoEllipse Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lLeftTailPercentage As Long, ByVal lRightTailPercentage As Long, ByRef lLeftTail As Long, ByRef lRightTail As Long, ByRef lMean As Long, ByRef lMedian As Long, ByRef lEnergy As Long) As Integer
'DllExport long _stdcall FS_HistogramInfoEllipse(colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long lLeftTailPercentage, long lRightTailPercentage, long *lLeftTail, long *lRightTail, long *lMean, long *lMedian, long *lEnergy)
'Histograms an elliptical area of an image, and returns three percentiles, the mean and "energy".

Public Declare Function FS_HoughEnhancedTransform Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lSobelThreshold As Long, ByVal lMinAngle As Long, ByVal lMaxAngle As Long) As Long
'long _stdcall FS_HoughEnhancedTransform (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long lSobelThreshold, long lMinAngle, long lMaxAngle)
'Perform an enhanced hough transform.

Public Declare Function FS_HoughTransform Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lSobelThreshold As Long, ByVal lMinAngle As Long, ByVal lMaxAngle As Long) As Long
'long _stdcall HoughTransform (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long lSobelThreshold, long lMinAngle, long lMaxAngle)
'Perform a hough transform.

Public Declare Function FS_LaplacianFilter Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal fAbsolute As Boolean) As Long
'long _stdcall FS_LaplacianFilter (colour_image* src, colour_image** pdest, BOOL bAbsolute)

Public Declare Function FS_LinearCorrelation Lib "ImageFunctions.dll" (ByVal pReferenceImage As Long, ByVal pSampleImage As Long, ByRef lOffset As Long, ByRef dScore As Double) As Long
'long _stdcall FS_LinearCorrelation(colour_image* imgRef, colour_image* imgSample, long* lResultOffset, double* dScore)
'Correlates two projections to get an offset

Public Declare Function FS_MaxImage Lib "ImageFunctions.dll" (ByVal Src1 As Long, ByVal Src2 As Long, ByRef dest As Long) As Long
'long _stdcall MaxImage(colour_image* src1, colour_image* src2, colour_image* dest)
'Writes to a destination in which each pixel is the maximum of the two equivalent source pixels

Public Declare Function FS_MeanImage Lib "ImageFunctions.dll" (ByVal Src1 As Long, ByVal Src2 As Long, ByRef dest As Long) As Long
'long _stdcall MeanImage(colour_image* src1, colour_image* src2, colour_image* dest)
'Writes to a destination image in which each pixel is the mean of the two equivalent source pixels

Public Declare Function FS_MinImage Lib "ImageFunctions.dll" (ByVal Src1 As Long, ByVal Src2 As Long, ByRef dest As Long) As Long
'long _stdcall MinImage(colour_image* src1, colour_image* src2, colour_image* dest)
'Writes to a destination image in which each pixel is the minimum of the two equivalent source pixels

Public Declare Function FS_MonoToColour Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long) As Long
'long _stdcall FS_MonoToColour(colour_image* src, colour_image** pdest)
'Converts a mono image to a colour one

Public Declare Function FS_MultiplyValue Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal dValue As Double) As Long
'long _stdcall MultiplyValue(colour_image* src, colour_image* dest, double dValue)
'Writes to a destination image in which each source pixel has been multiplied by a value

Public Declare Function FS_NegateImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long) As Long
'long _stdcall NegateImage(colour_image* src, colour_image* dest, long lValue)
'Negates an image

'Public Declare Function FS_NormaliseImage Lib "ImageFunctions.dll" (ByVal Image As Long, ByVal ImageDest As Long, ByVal lLeftTail As Long, ByVal lRightTail As Long) As Long
''long _stdcall NormaliseImage(IMG pImageIn1, IMG pImageDest, long lLeftTail, long lRightTail)
''Actually a histogram stretch

Public Declare Function FS_OrImage Lib "ImageFunctions.dll" (ByVal Src1 As Long, ByVal Src2 As Long, ByRef dest As Long) As Long
'long _stdcall OrImage(colour_image* src1, colour_image* src2, colour_image* dest)
'Writes to a destination image in which each pixel is the logical OR of the two equivalent source pixels

Public Declare Function FS_PixelMap Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByRef bMap As Byte) As Long
'long _stdcall PixelMap (colour_image* src, colour_image* dest, unsigned char *ucMap)
'The call requires Dim Map(256) as byte, and Map(0) is passed to the function

Public Declare Function FS_PolarUnwrap Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lCentreX As Long, ByVal lCentreY As Long, ByVal lInnerRadius As Long, ByVal lOuterRadius As Long, ByVal lStartAngle As Long, ByVal lEndAngle As Long) As Long
'long _stdcall PolarUnwrap (colour_image* src, colour_image* dest, long lCentreX, long lCentreY, long lInnerRadius, long lOuterRadius, long lStartAngle, long lEndAngle)
'Performs a polar unwrap

Public Declare Function FS_ProjectH Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long) As Long
'long _stdcall ProjectH (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom)
'Performs a horizontal projection

Public Declare Function FS_ProjectV Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long) As Long
'long _stdcall ProjectV (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom)
'Performs a vertical projection

Public Declare Function FS_RescaleImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lOffset As Long, ByVal dMultiplier As Double) As Long
'long _stdcall FS_RescaleImage(colour_image* src, colour_image** pdest, long lOffset, double dMultiplier)
'Add an offset to an image and then multiply it. Single function for speed reasons

Public Declare Function FS_RotateCircleSmoothed Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lCentreX As Long, ByVal lCentreY As Long, ByVal lRadius As Long, ByVal Angle As Double) As Long
'long _stdcall FS_RotateCircleSmoothed (colour_image* src, colour_image** pdest, long lCentreX, long lCentreY, long lRadius, double dAngle)
'Fills a destination image from a rotated source image blanking pixels that fall outside the source image.
'The angle is in degrees.

Public Declare Function FS_RotateImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lCentreX As Long, ByVal lCentreY As Long, ByVal Angle As Double) As Long
'long _stdcall RotateImage (colour_image* src, colour_image* dest, long lCentreX, long lCentreY, double dAngle)
'Fills a destination image from a rotated source image blanking pixels that fall outside the source image.
'The angle is in degrees.

Public Declare Function FS_RotateImageSmoothed Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lCentreX As Long, ByVal lCentreY As Long, ByVal Angle As Double) As Long
'long _stdcall RotateImageSmoothed (colour_image* src, colour_image* dest, long lCentreX, long lCentreY, double dAngle)
'Fills a destination image from a rotated source image blanking pixels that fall outside the source image.
'The angle is in degrees.

Public Declare Function FS_SelectColour Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lRed As Long, ByVal lGreen As Long, ByVal lBlue As Long, ByVal lColourTolerance As Double, ByVal lBrightnessTolerance As Long) As Long
'long _stdcall SelectColour (colour_image* src, colour_image** pdest, long lRed, long lGreen, long lBlue, double dColourTolerance, long lBrightnessTolerance)
'Create a mono image based on the selected colour and tolerance

Public Declare Function FS_SmartBinarise Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lXFilterSize As Long, ByVal lYFilterSize As Long, ByVal lMinContrast As Long, ByVal lMinThreshold As Long, ByVal lMaxThreshold As Long) As Long
'long _stdcall SmartBinarise(colour_image* src, colour_image* dest, long lL, long lT, long lR, long lB, long lXFilterSize, long lYFilterSize, long lMinContrast, long lMinThreshold, long lMaxThreshold)
'Binarises an image with automatic thresholding

Public Declare Function FS_LocalContrast Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lGranularityH As Long, ByVal lGranularityV As Long, ByVal lStepX As Long, ByVal lStepY As Long) As Long
'long _stdcall FS_LocalContrast(colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom, long lGranularityH, long lGranularityV, long lStepX, long lStepY)
'Creates an image showing the difference from the local background

Public Declare Function FS_SmoothedImage Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lGranularityH As Long, ByVal lGranularityV As Long, ByVal lStepX As Long, ByVal lStepY As Long) As Long
'long _stdcall FS_SmoothedImage(colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom, long lGranularityH, long lGranularityV, long lStepX, long lStepY)
'Creates a smoothed version of the source image

Public Declare Function FS_SobelAngle Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lThreshold As Long) As Long
'long _stdcall SobelAngle (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long lThreshold)
'Performs a Sobel angle filter

Public Declare Function FS_SobelEmboss Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long) As Long
'long _stdcall SobelEmboss (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom)
'Performs a Sobel emboss filter

Public Declare Function FS_SobelFilter Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long) As Long
'long _stdcall SobelFilter (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom)
'Performs a Sobel magnitude filter

Public Declare Function FS_SobelFilterAnnulus Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lThickness As Long) As Long
'long _stdcall FS_SobelFilterAnnulus (colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom, long lThickness)
'Performs a Sobel magnitude filter on an annular region

Public Declare Function FS_SobelToMono Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long) As Long
'long _stdcall FS_SobelToMono (colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom);
'Performs a Sobel magnitude filter with a mono result image where the maximum value in each plane is used.

Public Declare Function FS_SubtractImage Lib "ImageFunctions.dll" (ByVal Src1 As Long, ByVal Src2 As Long, ByRef dest As Long) As Long
'long _stdcall SubtractImage(colour_image* src1, colour_image* src2, colour_image* dest)
'Adds two images together
'Does not wrap round so subracting 128 from 97 gives 0

'################
'Search functions
'################
'Search model functions

Public Declare Function FS_OSModelTrain Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lPlane As Long, ByRef pModel As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lMaxScale As Long, ByVal lQuality As Long) As Long
'long _stdcall FS_OSModelTrain (colour_image *src, long lPlane, long* pTrainedModel, long lLeft, long lTop, long lRight, long lBottom, long lMaxScale, long lQuality);
'Train a model

Public Declare Function FS_OSModelUse Lib "ImageFunctions.dll" (ByVal src As Long, ByVal hModel As Long, ByVal lMinScore As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef dResultX As Double, ByRef dResultY As Double, ByRef dScore As Double, ByRef lResultCount As Long, ByRef hResults As Long) As Long
'long _stdcall FS_OSModelUse (colour_image *src, colour_image **pdest, long pTrainedModel, long lScore, long lLeft, long lTop, long lRight, long lBottom, double *dResultX, double *dResultY, double *dScore, long *plResultCount, long *FullResults);
'Use a model to find up to 100 results

Public Declare Function FS_OSModelUseEx Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lPlane As Long, ByVal hModel As Long, ByVal pParams As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef dResultX As Double, ByRef dResultY As Double, ByRef dScore As Double, ByRef lResultCount As Long, ByRef hResults As Long) As Long
'long _stdcall FS_OSModelUseEx (colour_image *src, colour_image **pdest, long lPlane, long pTrainedModel, long pSearchParams, long lLeft, long lTop, long lRight, long lBottom, double *dResultX, double *dResultY, double *dScore, long *plResultCount, long *FullResults)
'Use a model with full parameter control

Public Declare Function FS_OSModelUseSingle Lib "ImageFunctions.dll" (ByVal src As Long, ByVal hModel As Long, ByVal lMinScore As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef dResultX As Double, ByRef dResultY As Double, ByRef dScore As Double) As Long
'long _stdcall FS_OSModelUseSingle (colour_image *src, long pTrainedModel, long lScore, long lLeft, long lTop, long lRight, long lBottom, double *dResultX, double *dResultY, double *dScore, long *plResultCount, long *FullResults);
'Use a model to find the best single result

Public Declare Function FS_OSModelUseFirst Lib "ImageFunctions.dll" (ByVal src As Long, ByVal hModel As Long, ByVal lMinScore As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef dResultX As Double, ByRef dResultY As Double, ByRef dScore As Double) As Long
'long _stdcall FS_OSModelUseFirst (colour_image *src, colour_image **pdest, long pTrainedModel, long lScore, long lLeft, long lTop, long lRight, long lBottom, double *dResultX, double *dResultY, double *dScore, long *plResultCount, long *FullResults);
'Use a model to find the first result and then stop

Public Declare Function FS_OSModelDelete Lib "ImageFunctions.dll" (ByRef pModel As Long) As Long
'long _stdcall FS_OSModelDelete (long* pTrainedModel)

Public Declare Function FS_OSModelGetIdentifier Lib "ImageFunctions" (ByVal pModel As Long) As Long
'long _stdcall FS_OSModelGetIdentifier (long pTrainedModel);
'Get the model's image. Do not delete it.

Public Declare Function FS_OSModelGetPlane Lib "ImageFunctions" (ByVal pModel As Long) As Long
'long _stdcall FS_OSModelGetPlane (long pTrainedModel);
'Get the colour plane a model was originally trained on

Public Declare Function FS_OSModelGetImage Lib "ImageFunctions" (ByVal pModel As Long, ByRef hImage As Long) As Long
'long _stdcall FS_OSModelGetImage (long lTrainedModel, colour_image** pImage)
'Get the model's image. Do not delete it.

Public Declare Function FS_OSModelGetScale Lib "ImageFunctions" (ByVal pModel As Long) As Long
'long _stdcall FS_OSModelGetScale (long pTrainedModel)
'Get the detail level of a model

Public Declare Function FS_OSModelSetOrigin Lib "ImageFunctions" (ByVal pModel As Long, ByVal lOriginX As Long, ByVal lOriginY As Long) As Long
'long _stdcall FS_OSModelSetOrigin (long lModel, long lOriginX, long lOriginY)

Public Declare Function FS_OSModelLoad Lib "ImageFunctions.dll" (ByRef hModel As Long, ByVal Filename As String) As Long
'long _stdcall FS_OSModelLoad (long* lpModel, char* sFileName)

Public Declare Function FS_OSModelSave Lib "ImageFunctions.dll" (ByVal hModel As Long, ByVal Filename As String) As Long
'long _stdcall FS_OSModelSave (long* lModel, char* sFileName)

Public Declare Function FS_OSCreateSearchParams Lib "ImageFunctions.dll" (ByRef pParams As Long, ByVal lMaxResults As Long, ByVal lMinScore As Long, ByVal lOptimumScore As Long, ByVal fHighAccuracy As Long) As Long
'long _stdcall FS_OSCreateSearchParams (long* pSearchParams, long lMaxResults, long lMinScore, long lOptimumScore)

Public Declare Function FS_OSDeleteSearchParams Lib "ImageFunctions.dll" (ByRef pParams As Long) As Long
'long _stdcall FS_OSDeleteSearchParams (long* pSearchParams)

Public Declare Function FS_OSGetResult Lib "ImageFunctions.dll" (ByVal hResults As Long, ByVal lIndex As Long, ByRef dResultX As Double, ByRef dResultY As Double, ByRef dScore As Double) As Long
'long _stdcall FS_OSGetResult (long pModel, long lIndex, double *dResultX, double *dResultY, double *dScore)

Public Declare Function FS_OSDeleteResults Lib "ImageFunctions.dll" (ByRef hResults As Long) As Long
'long _stdcall FS_OSDeleteResults (long* pResults)

'Search model list functions
'Note indicies are one based
'Models and their images must not be deleted externally except prior to deleting the list only

Public Declare Function FS_OSModelListAddModel Lib "ImageFunctions.dll" (ByRef hModelList As Long, ByVal hModel As Long, ByVal lIdentifier As Long) As Long
'long _stdcall FS_OSModelListAddModel (long *plModelList, long pModel, long lIdentifier);
'Add a model to a list for multiple searchs - models must not be deleted externally

Public Declare Function FS_OSModelListAddModelEx Lib "ImageFunctions.dll" (ByRef hModelList As Long, ByRef lIndex As Long, ByVal hModel As Long, ByVal lIdentifier As Long) As Long
'long _stdcall FS_OSModelListAddModelEx (long *plModelList, long* plIndex, long pModel, long lIdentifier);
'Add a model to a list for multiple searchs - models must not be deleted externally

Public Declare Function FS_OSModelListModel Lib "ImageFunctions.dll" (ByVal hModelList As Long, ByVal lIndex As Long, ByRef hModel As Long) As Long
'long _stdcall FS_OSModelListModel (long pModelList, long lIndex, long* plModel);
'Get a model from a list - Do not delete

Public Declare Function FS_OSModelListDeleteItem Lib "ImageFunctions.dll" (ByRef hModelList As Long, ByVal lIndex As Long, ByVal bDeleteModel As Boolean) As Long
'long _stdcall FS_OSModelListDeleteItem (long *plModelList, long lIndex, BOOL bDeleteModel);
'Remove a model from a list, and optionally delete the model.

Public Declare Function FS_OSModelListDelete Lib "ImageFunctions.dll" (ByRef hModelList As Long, ByVal fDeleteModels As Boolean) As Long
'long _stdcall FS_OSModelListDelete (long* pModelList, BOOL bDeleteModels)
'Delete a model list and the models referenced.

Public Declare Function FS_OSModelListUse Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lPlane As Long, ByVal hModelList As Long, ByVal lMinScore As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef lResultCount As Long, ByRef hResults As Long) As Long
'long FS_OSModelListUse (colour_image *src, long lPlane, long pModelList, long lMinScore, long lLeft, long lTop, long lRight, long lBottom, long *plResultCount, long *FullResults)

Public Declare Function FS_OSModelListUseSingle Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lPlane As Long, ByVal hModelList As Long, ByVal lMinScore As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef lResultCount As Long, ByRef hResults As Long) As Long
'long _stdcall FS_OSModelListUseSingle (colour_image *src, long lPlane, long pModelList, long lMinScore, long lLeft, long lTop, long lRight, long lBottom, long *plResultCount, long *FullResults)

Public Declare Function FS_OSModelListUseFirst Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lPlane As Long, ByVal hModelList As Long, ByVal lMinScore As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef lResultCount As Long, ByRef hResults As Long) As Long
'long _stdcall FS_OSModelListUseFirst (colour_image *src, long lPlane, long pModelList, long lMinScore, long lLeft, long lTop, long lRight, long lBottom, long *plResultCount, long *FullResults)

Public Declare Function FS_OSModelListResult Lib "ImageFunctions.dll" (ByVal hResults As Long, ByVal lIndex As Long, ByRef dResultX As Double, ByRef dResultY As Double, ByRef dScore As Double, ByRef lIdentifier As Long) As Long
'long _stdcall FS_OSModelListResult (long pResults, long lIndex, double *dResultX, double *dResultY, double *dScore, long* lIdentifier)

Public Declare Function FS_OSModelListResultEx Lib "ImageFunctions.dll" (ByVal hResults As Long, ByVal lIndex As Long, ByRef dResultX As Double, ByRef dResultY As Double, ByRef dScore As Double, ByRef lModel As Long) As Long
'long _stdcall FS_OSModelListResultEx (long pResults, long lIndex, double *dResultX, double *dResultY, double *dScore, long* lModel)

Public Declare Function FS_OSModelListCount Lib "ImageFunctions.dll" (ByVal hModelList As Long, ByRef lNumberOfModels As Long) As Long
'long _stdcall FS_OSGetModelListCount (long* pModelList, long* lModels);
'Get the number of models in a list

Public Declare Function FS_OSModelListExtent Lib "ImageFunctions.dll" (ByVal hModelList As Long, ByRef lMaxWidth As Long, ByRef lMaxHeight As Long) As Long
'long _stdcall FS_OSModelListExtent (long pModelList, long* plMaxWidth, long *plMaxHeight);
'The largest model dimension in each direction - not necessarily the same model

Public Declare Function FS_OSModelListFontImage Lib "ImageFunctions.dll" (ByRef hListImage As Long, ByVal hModelList As Long, ByRef plThumbnailSizeX As Long, ByRef plThumbnailSizeY As Long) As Long
'long _stdcall FS_OSModelListFontImage (colour_image** pFontImage, long lModelList, long* plThumbnailSizeX, long* plThumbnailSizeY)
'Creates a composite image representing the model list

Public Declare Function FS_OSModelListLoad Lib "ImageFunctions.dll" (ByRef hModelList As Long, ByVal Filename As String) As Long
'long _stdcall FS_OSModelListLoad (long* lpModelList, char* sFileName)

Public Declare Function FS_OSModelListSave Lib "ImageFunctions.dll" (ByVal hModelList As Long, ByVal Filename As String) As Long
'long _stdcall FS_OSModelListSave (long* lModelList, char* sFileName)


'##############
'Blob functions
'##############
Public Declare Function FS_BlobUse Lib "ImageFunctions.dll" (ByVal src As Long, ByRef results As Long, ByVal lLowThreshold As Long, ByVal lHighThreshold As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef lNumberOfBlobsFound As Long) As Long
'long _stdcall FS_BlobUse(colour_image* src, long* results, long lLowThreshold, long lHighThreshold, long lLeft, long lTop, long lRight, long lBottom, long* lNumberOfBlobsFound);
Public Declare Function FS_BlobUseEx Lib "ImageFunctions.dll" (ByVal params As Long, ByVal src As Long, ByRef results As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef lNumberOfBlobsFound As Long) As Long
'long _stdcall FS_BlobUseEx(long params, colour_image* src, long* results, long lLeft, long lTop, long lRight, long lBottom, long* lNumberOfBlobsFound);
Public Declare Function FS_BlobUseLightBlobs Lib "ImageFunctions.dll" (ByVal src As Long, ByRef results As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef lNumberOfBlobsFound As Long) As Long
'long _stdcall FS_BlobUseLightBlobs(colour_image* src, long* results, long lLeft, long lTop, long lRight, long lBottom, long* lNumberOfBlobsFound);
Public Declare Function FS_BlobUseDarkBlobs Lib "ImageFunctions.dll" (ByVal src As Long, ByRef results As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef lNumberOfBlobsFound As Long) As Long
'long _stdcall FS_BlobUseDarkBlobs(colour_image* src, long* results, long lLeft, long lTop, long lRight, long lBottom, long* lNumberOfBlobsFound);
Public Declare Function FS_SetBlobParams Lib "ImageFunctions.dll" (ByRef params As Long, ByVal lLowThreshold As Long, ByVal lHighThreshold As Long, ByVal lMaxNumberOfBlobs As Long, ByVal lMaxTotalArea As Long, ByVal lMinBlobArea As Long, ByVal lMaxBlobArea As Long) As Long
'long _stdcall SetBlobParams(long* params, long lLowThreshold, long lHighThreshold, long lMaxNumberOfBlobs, long lMaxTotalArea, long lMinBlobArea, long lMaxBlobArea);
Public Declare Function FS_SetBlobParamsEx Lib "ImageFunctions.dll" (ByRef params As Long, ByVal lLowThreshold As Long, ByVal lHighThreshold As Long, ByVal lMaxNumberOfBlobs As Long, ByVal lMaxTotalArea As Long, ByVal lMinBlobArea As Long, ByVal lMaxBlobArea As Long, ByVal lMinDist As Long, ByVal lIntensityTolerance As Long, ByVal dColourTolerance As Double) As Long
'long _stdcall FS_SetBlobParamsEx(long* params, long lLowThreshold, long lHighThreshold, long lMaxNumberOfBlobs, long lMaxTotalArea, long lMinBlobArea, long lMaxBlobArea, long lMinDist, long lIntensityTolerance, double dColourTolerance)
Public Declare Function FS_DeleteBlobParams Lib "ImageFunctions.dll" (ByRef params As Long) As Long
'long _stdcall DeleteBlobParams(long* params);
Public Declare Function FS_DeleteBlobResults Lib "ImageFunctions.dll" (ByRef results As Long) As Long
'long _stdcall DeleteBlobResults(long* results);
Public Declare Function FS_BlobGet Lib "ImageFunctions.dll" (ByVal results As Long, ByVal lIndex As Long, ByRef pBlob As Long) As Long
'long _stdcall FS_BlobGet(long results, long lIndex, long* pBlob)
Public Declare Function FS_BlobAngle Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByRef dAngle As Double) As Long
'long _stdcall FS_BlobAngle(long lBlob, double* pdAngle)
Public Declare Function FS_BlobArea Lib "ImageFunctions.dll" (ByVal pBlob As Long) As Long
'long _stdcall FS_BlobArea(long pBlob)
Public Declare Function FS_BlobMaxDiameter Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByRef lDiameter As Long) As Long
'long _stdcall FS_BlobMaxDiameter(long lBlob, long* pDiameter)
Public Declare Function FS_BlobCentreX Lib "ImageFunctions.dll" (ByVal pBlob As Long) As Double
'double _stdcall FS_BlobCentreX(long pBlob)
Public Declare Function FS_BlobCentreY Lib "ImageFunctions.dll" (ByVal pBlob As Long) As Double
'double _stdcall FS_BlobCentreY(long pBlob)
Public Declare Function FS_BlobMinX Lib "ImageFunctions.dll" (ByVal pBlob As Long) As Long
'long _stdcall FS_BlobMinX(long pBlob)
Public Declare Function FS_BlobMinY Lib "ImageFunctions.dll" (ByVal pBlob As Long) As Long
'long _stdcall FS_BlobMinY(long pBlob)
Public Declare Function FS_BlobMaxX Lib "ImageFunctions.dll" (ByVal pBlob As Long) As Long
'long _stdcall FS_BlobMaxX(long pBlob)
Public Declare Function FS_BlobMaxY Lib "ImageFunctions.dll" (ByVal pBlob As Long) As Long
'long _stdcall FS_BlobMaxY(long pBlob)
Public Declare Function FS_BlobBasicInfo Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByRef lArea As Long, ByRef dCentreX As Double, ByRef dCentreY As Double) As Long
'long _stdcall FS_BlobBasicInfo(long pBlob, long* lArea, double* dCentreX, double* dCentreY)
Public Declare Function FS_BlobPaint Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByVal hImage As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal fFillHoles As Long) As Long
'long _stdcall FS_BlobPaint(long lBlob, colour_image* dest, long lLeft, long lTop, long lFillHoles)
Public Declare Function FS_BlobPerimeterLength Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByRef lLength As Long) As Long
'long _stdcall FS_BlobPerimeterLength(long pBlob, long* pLength)
Public Declare Function FS_BlobPerimeterPoint Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByVal lIndex As Long, ByRef lPointX As Long, ByRef lPointY As Long) As Long
'long _stdcall FS_BlobPerimeterPoint(long pBlob, long lIndex, long* plPointX, long* plPointY)
Public Declare Function FS_BlobLargest Lib "ImageFunctions.dll" (ByVal results As Long, ByRef pLargestBlob As Long) As Long
'long _stdcall FS_BlobLargest(long lResults, blob_data** pLargestBlob)
Public Declare Function FS_BlobRoundness Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByRef dRoundness As Double) As Long
'long _stdcall FS_BlobRoundness(long lBlob, double* pdRoundness)
Public Declare Function FS_BlobNext Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByRef pNextBlob As Long) As Long
'long _stdcall FS_BlobNext(long lBlob, long* pNext)
Public Declare Function FS_BlobHoleArea Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByRef lHoleArea As Long) As Long
'long _stdcall FS_BlobHoleArea(long lBlob, long* lHoleArea)
Public Declare Function FS_BlobCompareResults Lib "ImageFunctions.dll" (ByVal hReference As Long, ByVal hTest As Long, ByVal lAreaTolerancePercent As Long, ByVal lDistanceTolerancePercent As Long, ByVal lAngleToleranceDegrees As Long, ByRef lScore As Long, ByRef lAngleDegrees As Long, ByRef lOffsetX As Long, ByRef lOffsetY As Long) As Long
'long _stdcall FS_BlobCompareResults(void* Reference, void* Test, long lAreaTolerancePercent, long lDistanceTolerancePercent, long lAngleToleranceDegress, long* lScore, long* lAngleDegrees, long* lOffsetX, long* lOffsetY)
Public Declare Function FS_BlobPeak Lib "ImageFunctions.dll" (ByVal pBlob As Long, ByVal hImage As Long, ByVal lLeft As Long, ByVal lTop As Long, ByRef lPeakX As Long, ByRef lPeakY As Long) As Long
'long _stdcall FS_BlobPeak(long lBlob, colour_image* src, long lLeft, long lTop, long* lPeak, long* lPeakX, long* lPeakY)


'################
'Code Finder functions
'################
Public Declare Function FS_FindCodes Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lMinCharWidth As Long, ByVal lMinCharHeight As Long, ByVal lMinContrast As Long, ByVal lBlackLevel As Long, ByVal lWhiteLevel As Long, ByVal lFilter As Long, ByVal lSharpness As Long, ByVal fDarkCharacters As Long, ByRef hResults As Long, ByRef lNumberOfCodes As Long) As Long
'long _stdcall FS_FindCodes(colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long lMinCharWidth, long lMinCharHeight, long lMinContrast, long lBlackLevel, long lWhiteLevel, long lFilter, long lSharpness, long lDarkCharacters, void** pResults, long* lNumberOfCodes)
Public Declare Function FS_GetCode Lib "ImageFunctions.dll" (ByVal hResults As Long, ByVal lIndex As Long, ByRef lCharacterHeight As Long, ByRef lLeft As Long, ByRef lTop As Long, ByRef lRight As Long, ByRef lBottom As Long) As Long
'long _stdcall FS_GetCode(void* pResults, long lIndex, long* lCharacterHeight, long* lMinX, long* lMinY, long* lMaxX, long* lMaxY);
Public Declare Function FS_DeleteCode Lib "ImageFunctions.dll" (ByRef hResults As Long) As Long
'long _stdcall FS_DeleteCode(void** pResults);
'################
'Colour functions
'################
Public Declare Function FS_AddColourRegionToProfile Lib "ImageFunctions.dll" (ByRef hProfile As Long, ByVal lColourRGB As Long, ByVal lWeight As Long, ByVal dColourTolerance As Double, ByVal lBrightnessTolerance As Long) As Long
'long _stdcall FS_AddColourRegionToProfile (long** hProfile, long lColourRGB, long lWeight, double dColourTolerance, long lBrightnessTolerance);
Public Declare Function FS_CompareColourProfiles Lib "ImageFunctions.dll" (ByVal hProfileSrc1 As Long, ByVal hProfileSrc2 As Long, ByRef plScore As Long) As Long
'long _stdcall FS_CompareColourProfiles (long* hProfileSrc1, long* hProfileSrc2, long* plScore);
Public Declare Function FS_CompareColourRange Lib "ImageFunctions.dll" (ByVal hProfileSrc1 As Long, ByVal hProfileSrc2 As Long, ByRef plScore As Long) As Long
'long _stdcall FS_CompareColourRange (long* hProfileSrc1, long* hProfileSrc2, long* plScore)
Public Declare Function FS_CopyColourProfile Lib "ImageFunctions.dll" (ByVal hProfileSrc1 As Long, ByRef hProfileDest As Long) As Long
'long _stdcall FS_CopyColourProfile (long* hProfileSrc, long** hProfileDest);
Public Declare Function FS_CreateColourProfileImage Lib "ImageFunctions.dll" (ByVal hProfile As Long, ByRef hDest As Long) As Long
'long _stdcall FS_CreateColourProfileImage (long* hProfile, colour_image** hDest)
Public Declare Function FS_CreateColourProfileMask Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal hProfile As Long) As Long
'long _stdcall FS_CreateProfileMask (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long* hProfile);
Public Declare Function FS_DeleteColourProfile Lib "ImageFunctions.dll" (ByRef hProfile As Long) As Long
'long _stdcall FS_DeleteColourProfile (long** hProfile);
Public Declare Function FS_ExpandColourProfile Lib "ImageFunctions.dll" (ByVal hProfile As Long, ByVal dColourTolerance As Double, ByVal lBrightnessTolerance As Long) As Long
'long _stdcall FS_ExpandColourProfile (long* hProfile, double dColourTolerance, long lBrightnessTolerance);
Public Declare Function FS_GetColourProfile Lib "ImageFunctions.dll" (ByVal src As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef hProfile As Long) As Long
'long _stdcall FS_GetColourProfile (colour_image* src, long lLeft, long lTop, long lRight, long lBottom, long** hProfile);
Public Declare Function FS_MergeColourProfiles Lib "ImageFunctions.dll" (ByVal hProfileSrc1 As Long, ByVal hProfileSrc2 As Long, ByRef hProfileDest As Long) As Long
'long _stdcall FS_MergeColourProfiles (long* hProfileSrc1, long* hProfileSrc2, long** hProfileDest);
Public Declare Function FS_Posterise Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long) As Long
'long _stdcall FS_Posterise (colour_image* src, colour_image** pdest);
Public Declare Function FS_SegmentProfile Lib "ImageFunctions.dll" (ByVal hProfile As Long, ByRef hPrimaryProfile As Long, ByVal dColourTolerance As Double, ByVal lBrightnessTolerance As Long) As Long
'long _stdcall FS_SegmentProfile (long* hSourceProfile, long** phPrimaryProfile, double dColourTolerance, long lBrightnessTolerance)
Public Declare Function FS_SelectColourProfile Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal hProfile As Long) As Long
'long _stdcall FS_SelectColourProfile (colour_image* src, colour_image* dest, long lLeft, long lTop, long lRight, long lBottom, long* hProfile);
Public Declare Function FS_SubtractColourProfile Lib "ImageFunctions.dll" (ByVal hProfileRef As Long, ByVal hProfileToSubtract As Long, ByRef hProfileDest As Long) As Long
'long _stdcall FS_SubtractColourProfile (long* hProfileRef, long* hProfileToSubtract, long** hProfileDest)

Public Declare Function FS_LoadColourProfile Lib "ImageFunctions.dll" (ByRef hProfile As Long, ByVal Filename As String) As Long
'long _stdcall FS_LoadProfile (long** hProfile, char* sFileName);
Public Declare Function FS_SaveColourProfile Lib "ImageFunctions.dll" (ByVal hProfile As Long, ByVal Filename As String) As Long
'long _stdcall FS_SaveProfile (long* hProfile, char* sFileName);



'################
'Helper functions
'################
Public Declare Function FS_LoadImage Lib "ImageFunctions.dll" (ByVal Filename As String, ByRef Image As Long) As Long
'long _stdcall LoadFSImage(const char *filename, colour_image **pdest)

Public Declare Function FS_SaveImage Lib "ImageFunctions.dll" (ByVal Image As Long, ByVal Filename As String) As Long
'long _stdcall SaveFSImage(colour_image* hImage, char* sFileName)

Public Declare Function FS_ImageAreaTohDC Lib "ImageFunctions.dll" (ByVal Image As Long, ByVal hdc As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByVal lTargetLeftPixels As Long, ByVal lTargetTopPixels As Long, ByVal lTargetWidthPixels As Long, ByVal lTargetHeightPixels As Long) As Long
'long _stdcall FSImageAreaTohDC(colour_image* src, HDC hDC, long lLeft, long lTop, long lRight, long lBottom, long lTargetLeftPixels, long lTargetTopPixels, long lTargetWidthPixels, long lTargetHeightPixels)

Public Declare Function FS_ImageTohDC Lib "ImageFunctions.dll" (ByVal Image As Long, ByVal hdc As Long, ByVal lTargetLeftPixels As Long, ByVal lTargetTopPixels As Long, ByVal lTargetWidthPixels As Long, ByVal lTargetHeightPixels As Long) As Long
'long _stdcall FSImageTohDC(colour_image* hImage, HDC* hDC, long lTargetLeftPixels, long lTargetTopPixels, long lTargetWidthPixels, long lTargetHeightPixels)

Public Declare Function FS_CheckRegistration Lib "ImageFunctions.dll" () As Long
'long _stdcall CheckRegistration()

Public Declare Function FS_ActivateLibraries Lib "ImageFunctions.dll" (ByVal sKey As String, ByVal sActivationCode As String) As Long
'long _stdcall FS_ActivateLibraries(char* pcForeshoreKey, char* pcReqKey)

Public Declare Function FS_ActivateLibrariesSerial Lib "ImageFunctions.dll" (ByVal sSerialNumber As String, ByVal sKey As String, ByVal sActivationCode As String) As Long
'long _stdcall FS_ActivateLibrariesSerial(char* sSerialNumber, char* sForeshoreKey, char* sReqKey)

Public Declare Function FS_IsLibraryActivated Lib "ImageFunctions.dll" () As Boolean
'BOOL _stdcall FS_IsLibraryActivated();

Public Declare Function FS_ImageToPicture Lib "ImageFunctions.dll" (ByVal hImage As Long, ByRef aPicture As StdPicture) As Long
'long _stdcall FSImageToPicture(colour_image* hImage, LPPICTUREDISP *pPicture)

'Public Declare Function FS_ImageFromPicture Lib "ImageFunctions.dll" (ByRef hImage As Long, ByVal aPicture As StdPicture) As Long
'long _stdcall FSImageFromPicture(colour_image** pdest, LPPICTUREDISP pPicture)

Public Declare Function FS_ImageToClipboard Lib "ImageFunctions.dll" (ByVal hImage As Long, ByVal hwnd As Long) As Long
'long _stdcall FSImageToClipboard(colour_image* hImage, HWND hWnd)

Public Declare Function FS_ResetTimeMicroSeconds Lib "ImageFunctions.dll" () As Long
'long _stdcall ResetTimeMicroSeconds()

Public Declare Function FS_GetTimeMicroSeconds Lib "ImageFunctions.dll" () As Double
'double _stdcall GetTimeMicroSeconds()

Public Declare Sub FS_SetHandleProtection Lib "ImageFunctions.dll" (ByVal lProtectionOn As Long)
'void _stdcall FS_SetHandleProtection(long lProtectionOn)
'Turns handle protection functionality on/off, the default is on. In this case an invalid image handle will raise a pointer error.

'Utility functions
Public Declare Function FS_ArcCos Lib "ImageFunctions.dll" (ByVal dValue As Double) As Double
'double _stdcall ArcCos (double dValue);

Public Declare Function FS_ArcSin Lib "ImageFunctions.dll" (ByVal dValue As Double) As Double
'double _stdcall ArcSin (double dValue);

Public Declare Function FS_RadiansToDegrees Lib "ImageFunctions.dll" (ByVal dValue As Double) As Double
'double _stdcall RadiansToDegrees (double dValue);

Public Declare Function FS_DegreesToRadians Lib "ImageFunctions.dll" (ByVal dValue As Double) As Double
'double _stdcall DegreesToRadians (double dValue);

Public Declare Function FS_AngleFromPoint Lib "ImageFunctions.dll" (ByVal lPointX As Long, ByVal lPointY As Long) As Double
'long _stdcall FS_AngleFromPoint (long lPointX, long lPointY)'Because this comes up so frequently
'In the range 0-360, measured clockwise from the 3 o'clock position.

'########################
'Code functions functions
'########################

Public Declare Function FS_TopHatFilter Lib "ImageFunctions.dll" (ByVal hImage As Long, ByRef hDest As Long, ByVal lLeft As Long, ByVal lRight As Long, ByVal lTop As Long, ByVal lBottom As Long, ByVal lSrcRadius As Long, ByVal lDestRadius As Long) As Long
Public Declare Function FS_FindCodeWindow Lib "ImageFunctions.dll" (ByVal hImage As Long, ByRef hDest As Long, ByRef lLeft As Long, ByRef lTop As Long, ByRef lRight As Long, ByRef lBottom As Long) As Long
'long _stdcall FS_FindCodeWindow(colour_image* src, colour_image** pdest, long *lCodeLeft, long *lCodeTop, long *lCodeRight, long *lCodeBottom)

Public Declare Function FS_AutoSegment Lib "ImageFunctions.dll" (ByVal hImage As Long, ByRef hDest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef plNumberOfPoints As Long, ByRef pResults As Long) As Long
'long _stdcall FS_AutoSegment(colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom, long *plNumberOfResults, point_data** pResults)

'long _stdcall FS_TopHatFilter(colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom, long lSrcRadius, long lDestRadius)

Public Declare Function FS_PointChecker Lib "ImageFunctions.dll" (ByVal hImage As Long, ByRef hDest As Long, ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long, ByRef plNumberOfPoints As Long, ByRef pResults As Long) As Long
'long _stdcall FS_PointChecker(colour_image* src, colour_image** pdest, long lLeft, long lTop, long lRight, long lBottom, long *plNumberOfResults, point_data** pResults)

Public Declare Function FS_PointListDeleteResults Lib "ImageFunctions.dll" (ByRef pResults As Long) As Long
'long _stdcall FS_PointListDeleteResults(point_data** pResults)

Public Declare Function FS_PointListGetResult Lib "ImageFunctions.dll" (ByVal pResults As Long, ByVal lIndex As Long, ByRef plPointX As Long, ByRef plPointY As Long) As Long
'long _stdcall FS_PointListGetResult(point_data* pResults, long lIndex, long *plResultX, long * plResultY)

Public Declare Function FS_RectListDeleteResults Lib "ImageFunctions.dll" (ByRef pResults As Long) As Long
'long _stdcall FS_RectListDeleteResults(rect_data** pResults)

Public Declare Function FS_RectListGetResult Lib "ImageFunctions.dll" (ByVal pResults As Long, ByVal lIndex As Long, ByRef plLeft As Long, ByRef plTop As Long, ByRef plRight As Long, ByRef plBottom As Long) As Long
'long _stdcall FS_RectListGetResult(rect_data* pResults, long lIndex, long *plLeft, long * plTop, long *plRight, long * plBottom)

Public Declare Function TrainShowGo Lib "ImageFunctions.dll" (ByVal hImage As Long, ByVal lWindowL As Long, ByVal lWindowT As Long, ByVal lWindowR As Long, ByVal lWindowB As Long, ByVal lMinCharacterWidth As Long, ByVal lMinNumCharacters As Long) As Long
Public Declare Function UseShowGo Lib "ImageFunctions.dll" (ByVal hImage As Long, ByVal lLeft As Long, ByVal lRight As Long, ByVal lTop As Long, ByVal lBottom As Long, ByRef lScore As Long, ByVal lMinimumScore As Long) As Long

'########################
'Affine functions functions
'########################

Public Declare Function FS_SetTransformData Lib "ImageFunctions.dll" (ByRef ptdTransform As Long, ByVal dM00 As Double, ByVal dM01 As Double, ByVal dM10 As Double, ByVal dM11 As Double, ByVal dx As Double, ByVal dy As Double) As Long
'long _stdcall FS_SetTransformData(transform_data** ptdTransform, double dM00, double dM01, double dM10, double dM11, double dX, double dY)

Public Declare Function FS_DeleteTransformData Lib "ImageFunctions.dll" (ByRef ptdTransform As Long) As Long
'long _stdcall FS_DeleteTransformData(transform_data** ptdTransform)

Public Declare Function FS_TransformPoint Lib "ImageFunctions.dll" (ByVal tdTransform As Long, ByVal dx As Double, ByVal dy As Double, ByRef pdX As Double, ByRef pdY As Double) As Long
'long _stdcall FS_TransformPoint(transform_data* tdTransform, double dX, double dY, double* pdX, double* pdY)

Public Declare Function FS_InverseTransformPoint Lib "ImageFunctions.dll" (ByVal tdTransform As Long, ByVal dx As Double, ByVal dy As Double, ByRef pdX As Double, ByRef pdY As Double) As Long
'long _stdcall FS_InverseTransformPoint(transform_data* tdTransform, double dX, double dY, double* pdX, double* pdY)

Public Declare Function FS_TransformMerge Lib "ImageFunctions.dll" (ByVal tdTransform1 As Long, ByVal tdTransform2 As Long, ByRef ptdTransform As Long) As Long
'long _stdcall FS_TransformMerge(transform_data* tdTransform1, transform_data* tdTransform2, transform_data** ptdTransformResult)

Public Declare Function FS_AffineTransform Lib "ImageFunctions.dll" (ByVal src As Long, ByRef dest As Long, ByVal tdTransform As Long, ByVal lOriginX As Long, ByVal lOriginY As Long) As Long
'long _stdcall FS_AffineTransform (colour_image* src, colour_image** pdest, transform_data* tdTransform, long lOriginX, long lOriginY)

Public Declare Function FS_CreateShearTransform Lib "ImageFunctions.dll" (ByRef ptdTransform As Long, ByVal dHorizontalShearAngle As Double, ByVal dVerticalShearAngle As Double) As Long
'long _stdcall FS_CreateShearTransform(transform_data** ptdTransform, double dHorizontalShearAngle, double dVerticalShearAngle)

Public Declare Function FS_CreateRotateTransform Lib "ImageFunctions.dll" (ByRef ptdTransform As Long, ByVal dAngle As Double) As Long
'long _stdcall FS_CreateRotateTransform(transform_data** ptdTransform, double dAngle)

Public Declare Function FS_CreateRescaleTransform Lib "ImageFunctions.dll" (ByRef ptdTransform As Long, ByVal dHorizontalScale As Double, ByVal dVerticalScale As Double) As Long
'long _stdcall FS_CreateRescaleTransform(transform_data** ptdTransform, double dHorizontalScale, double dVerticalScale)

Public Declare Function FS_CreateTranslateTransform Lib "ImageFunctions.dll" (ByRef ptdTransform As Long, ByVal dHorizontalOffset As Double, ByVal dVerticalOffset As Double) As Long
'long _stdcall FS_CreateTranslateTransform(transform_data** ptdTransform, double dHorizontalOffset, double dVerticalOffset)

